#ifndef VEHICLE_H
#define VEHICLE_H

// $Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/ex/RCS/Vehicle.h,v 3.13 92/08/13 12:47:23 sandy Exp $

// Vehicle.h -- Abstract base class for various kinds of Vehicles

#ifndef MI
#define MI
#endif

#include "AllLink.h"
#include "QLink.h"
#include "AllVehicles.h"
#include <nihcl/IdentSet.h>

class Vehicle: public AllLink, public QLink {
    DECLARE_MEMBERS(Vehicle);
    static AllVehicles allVehicles;
    static IdentSet v;                  // used by printOn()
    unsigned id;
    float height;
    float length;
public:         // static member functions
    static void printAll(ostream& strm =cout);
    static void saveQueues(const char* fname, ...);
protected:      // storer() functions for object I/O
    virtual void storer(OIOofd&) const;
    virtual void storer(OIOout&) const;
protected:
    Vehicle(float h = 0.0, float l = 0.0);
#ifndef BUG_TOOBIG
// yacc stack overflow
    Vehicle(const Vehicle&);
#endif
    virtual void _printOn(ostream& strm =cout) const;
public:
    virtual ~Vehicle();
    bool operator==(const Vehicle&) const;
    bool operator!=(const Vehicle& a) const { return !(*this==a); }
    virtual int compare(const Object&) const;
    virtual void deepenShallowCopy();
    virtual Object* copy() const;
    virtual unsigned hash() const;
    virtual bool isEqual(const Object&) const;
    virtual void printOn(ostream& strm =cout) const;
};

#endif
