/* Arraychar.p -- type-specific functions for class Arraychar

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet: kgorlen@alw.nih.gov
	September, 1985

Function:
	
Type-specific functions for class Arraychar, such as hash() and
printOn().  Generic functions are generated from the m4 template file
Array.c.m4.

WARNING -- Make changes to the .p or .m4 files, not to the .c file
they generate.

$Log:	Arraychar.p,v $
 * Revision 3.15  92/12/19  15:55:34  sandy
 * removed extraneous semi-colon
 * 
 * Revision 3.14  92/07/26  14:30:54  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.13  92/05/25  11:13:41  sandy
 * __DECCXX compatible
 * 
 * Revision 3.12  92/05/25  10:29:02  sandy
 * DEFINE_CLASS macros use one initor
 * 
 * Revision 3.11  91/07/16  13:12:14  kgorlen
 * Simplify I/O statement to compile with iomanip.h templates.
 * 
 * Revision 3.10  91/02/18  21:05:36  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.0  90/05/20  00:19:00  kgorlen
 * Release for 1st edition.
 * 
*/

`#include' <nihcl/Arraychar.h>
`#include' <nihcl/nihclconfig.h>
`#include' <iomanip.h>
`#ifdef' __DECCXX
`#include'  <stdlib.h>
`#else'
`#include' <libc.h>
`#endif'
`#include' <nihcl/nihclIO.h>

`#define'	THIS	Arraychar
`#define'	BASE	Collection
#define BASE_CLASSES BASE::desc()
#define MEMBER_CLASSES
#define VIRTUAL_BASE_CLASSES

DEFINE_CLASS(Arraychar,1,"$Header: /afs/.alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/Arraychar.p,v 3.15 92/12/19 15:55:34 sandy Exp $",NULL)

static int charCmp(const void* a, const void* b)
{
	return *(const unsigned char*)a - *(const unsigned char*)b;
}

union hash_char_mask {
	unsigned in[sizeof(int)];
	char ch[sizeof(int)*sizeof(int)];
	hash_char_mask();
} mask;

hash_char_mask::hash_char_mask()
{
	for (register unsigned i=0; i<sizeof(int); i++) {
		for (register unsigned j=0; j<sizeof(int); j++) ch[sizeof(int)*i+j] = j<i ? 0xff : 0;
	}
}

unsigned THIS::hash() const
{
	register unsigned h = sz;
	register unsigned i = div_sizeof_int(sz);
	register unsigned* vv = (unsigned*)v;
	while (i--) h ^= *vv++;
	if ((i = mod_sizeof_int(sz)) != 0)
		h ^= *vv & mask.in[i];
	return h;
}

void THIS::printOn(ostream& strm) const
{
	for (register unsigned i=0; i<sz; i++) {
		if (i > 0) strm << "  ";
 		strm << "0x";
		strm << setfill('0');
		strm << setw(2) << hex << ((unsigned int)(unsigned char)v[i]);
	}
	strm << dec;
}

THIS::THIS(OIOin& strm)
:
#ifdef MI
	Object(strm),
#endif
	BASE(strm)
{
	strm >> sz;
	v = NEW(char,sz);
	strm.get(v,sz);
}

void THIS::storer(OIOout& strm) const
{
	BASE::storer(strm);
	strm << sz;
	strm.put(v,sz);
}

Arraychar::Arraychar(OIOifd& fd)
:
#ifdef MI
	Object(fd),
#endif
	BASE(fd)
{
	fd >> sz;
	v = NEW(char,sz);
	fd.get(v,sz);
}

void Arraychar::storer(OIOofd& fd) const
{
	BASE::storer(fd);
	fd << sz;
	fd.put(v,sz);
}

ARRAYIMPLEMENT(Arraychar,char)
