#ifndef	BAG_H
#define	BAG_H

/*$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/Bag.h,v 3.13 92/07/26 14:31:54 sandy Exp $*/

/* Bag.h -- declarations for Set of Objects with possible duplicates

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	Bag.h,v $
 * Revision 3.13  92/07/26  14:31:54  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.12  92/06/17  11:35:21  sandy
 * __DECCCXX compatible
 * 
 * Revision 3.11  91/07/16  13:18:56  kgorlen
 * Implement _reader() functions.
 * 
 * Revision 3.10  91/02/18  21:05:50  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.0  90/05/20  00:19:08  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/Collection.h>
#include <nihcl/Dictionary.h>

class Bag: public Collection {
	DECLARE_MEMBERS(Bag);
	unsigned count;
	Dictionary contents;
protected:
	void _reader(OIOifd&);	// read Bag from stream
	void _reader(OIOin&);	// read Bag from file
protected:		// storer() functions for object I/O
	virtual void storer(OIOofd&) const;
	virtual void storer(OIOout&) const;
public:
	Bag(unsigned size =DEFAULT_CAPACITY);
	Bag(const Bag&);
	~Bag();
	Object* addWithOccurrences(Object&, unsigned);
	bool operator!=(const Bag& a) const		{ return !(*this==a); }
	void operator=(const Bag&);
	bool operator==(const Bag&) const;
	virtual	Object*	add(Object&);
	virtual Object*& at(int);
#ifdef __DECCXX
// Workaround __DECCXX bug failing to disambiguate at() and at() const
	virtual const Object *const& at(long) const;
#else
	virtual const Object *const& at(int) const;
#endif
	virtual unsigned capacity() const;
	virtual void deepenShallowCopy();
	virtual Object*	doNext(Iterator&) const;
	virtual	void dumpOn(ostream& strm =cerr) const;
	virtual unsigned hash() const;
	virtual bool isEqual(const Object&) const;
	virtual unsigned occurrencesOf(const Object&) const;
	virtual void reSize(unsigned);
	virtual Object*	remove(const Object&);
	virtual void removeAll();
	virtual unsigned size() const;
	virtual const Class* species() const;
private:			    // shouldNotImplement()
	virtual int compare(const Object&) const;
};

#endif
