#ifndef	EXCEPTACT_H
#define	EXCEPTACT_H

/*$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/ExceptAct.h,v 3.11 92/07/26 14:32:13 sandy Exp $*/

/* ExceptAct.h -- declarations for exception actions

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	ExceptAct.h,v $
 * Revision 3.11  92/07/26  14:32:13  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.10  91/02/18  21:06:14  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  90/12/22  08:48:02  kgorlen
 * Change NESTED_TYPES to NO_NESTED_TYPES.
 * 
 * Revision 3.0  90/05/20  00:19:28  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/Exception.h>
#include <nihcl/nihclerrs.h>

class ExceptionAction;
class Process;

class ExceptionActionTbl : public NIHCL {
private:
	static ExceptionActionTbl* active;
	friend ExceptionAction;
	friend void NIHCL::setError(int error, int sev, ...);
	friend Process;
private:
#ifdef NO_NESTED_TYPES
	exceptionTrapTy client_exception_trap;
	exceptionActionTy action[NIHCL__LAST_ERROR-NIHCL__FIRSTERROR+1];
#else
	ExceptionTrap::exceptionTrapTy client_exception_trap;
	ExceptionAction::exceptionActionTy
		action[NIHCL__LAST_ERROR-NIHCL__FIRSTERROR+1];
#endif
	friend ExceptionAction;
	friend AbortException;
	friend RaiseException;
	friend ExceptionTrap;
public:
	ExceptionActionTbl();
	void act(unsigned error, int sev);
};

#endif
