#ifndef KEYSORTCLTNH
#define KEYSORTCLTNH

/* KeySortCltn.h -- header file for class KeySortCltn

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	S. M. Orlow
	Systex, Inc.
	Beltsville, MD 20705

Contractor:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

$Log:	KeySortCltn.h,v $
 * Revision 3.11  92/07/26  14:32:34  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.10  91/02/18  21:06:57  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  90/11/10  20:30:06  kgorlen
 * Eliminate deepenShallowCopy(), occurrencesOfKey(),
 * includesKey(), removeKey(), findIndexOf(), and
 * findRangeOfKey().
 * 
 * Revision 3.0  90/05/20  00:19:59  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/SortedCltn.h>
#include <nihcl/LookupKey.h>

class Assoc;

class KeySortCltn: public SortedCltn {
	DECLARE_MEMBERS(KeySortCltn);
#ifndef BUG_38
// internal <<AT&T C++ Translator 2.00 06/30/89>> error: bus error (or something nasty like that)
protected:		// storer() functions for object I/O
	virtual	void storer(OIOofd& fd)	const	{ SortedCltn::storer(fd); };
	virtual	void storer(OIOout& strm) const	{ SortedCltn::storer(strm); };
#endif
public:
	KeySortCltn(int size =DEFAULT_CAPACITY);
#ifndef BUG_TOOBIG
// yacc stack overflow
	KeySortCltn(const KeySortCltn&);
#endif

	virtual LookupKey* assocAt(int i);
	virtual Object* keyAt(int i);
	virtual Object* valueAt(int i);
	virtual Object* atKey(Object& key);

	virtual Assoc* addAssoc(Object& key,Object& val);
	virtual Collection& addValuesTo(Collection&) const;
	virtual Collection& addKeysTo(Collection&) const;
	virtual Collection& addContentsBeforeTo(Object&,Collection&);
};

#endif
