#ifndef	OIONIH_H
#define	OIONIH_H

/*$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/OIOnih.h,v 3.11 92/07/26 14:33:01 sandy Exp $*/

/* OIOnih.h -- declarations for "NIH-format" stream Object I/O classes

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892
	May, 1989

Modification History:

$Log:	OIOnih.h,v $
 * Revision 3.11  92/07/26  14:33:01  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.10  91/02/18  21:07:33  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  90/11/29  11:56:25  kgorlen
 * Add default capacity argument to constructors.
 * 
 * Revision 3.0  90/05/20  00:20:30  kgorlen
 * Release for 1st edition.
 * 
*/
#include <nihcl/OIOstream.h>

class OIOnihin : public OIOistream {
protected:
	virtual Object* readObject(const Class&);
public:
	OIOnihin(istream& s, unsigned capacity =1024) : OIOistream(s,capacity) {}
};

class OIOnihout : public OIOostream {
protected:
	virtual void storeObject(const Object&);
public:
	OIOnihout(ostream& s, unsigned capacity =256) : OIOostream(s,capacity) {}
};

#endif
