#ifndef	SEQCLTN_H
#define	SEQCLTN_H

/*$Header: /afs/.alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/SeqCltn.h,v 3.15 92/12/19 15:41:14 sandy Exp $*/

/* SeqCltn.h -- declarations for abstract sequential collections

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	SeqCltn.h,v $
 * Revision 3.15  92/12/19  15:41:14  sandy
 * Added abstract virtual reSize()
 * 
 * Revision 3.14  92/07/26  14:33:37  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.13  92/06/17  11:35:35  sandy
 * __DECCCXX compatible
 * 
 * Revision 3.12  92/05/28  15:41:26  sandy
 * corrected overloaded at()
 * 
 * Revision 3.11  92/04/30  15:44:50  sandy
 * added member SeqCltn::sameContentsInOrderAs()
 * 
 * Revision 3.10  91/02/18  21:08:17  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  90/11/10  21:36:22  kgorlen
 * Implement virtual unsigned capacity() const = 0.
 * 
 * Revision 3.0  90/05/20  00:21:13  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/Collection.h>

class SeqCltn: public Collection {
	DECLARE_MEMBERS(SeqCltn);
protected:
	SeqCltn();
	void indexRangeErr() const;
public:
	virtual	Object* add(Object&) = 0;
	virtual Object*& at(int) = 0;
#ifdef __DECCXX
// Workaround __DECCXX bug failing to disambiguate at() and at() const
	virtual const Object *const& at(long) const = 0;
#else
	virtual const Object *const& at(int) const = 0;
#endif
	virtual void atAllPut(Object& ob) = 0;
	virtual unsigned capacity() const = 0;
	virtual int compare(const Object&) const;
        virtual bool sameContentsInOrderAs(const SeqCltn& c) const;
	virtual Object* doNext(Iterator&) const;
	virtual Object* first() const;
	virtual unsigned hash() const;
	virtual bool isEqual(const Object&) const;
	virtual int indexOf(const Object& ob) const;
	virtual int indexOfSubCollection(const SeqCltn& cltn, int start=0) const = 0;
	virtual Object* last() const;
	virtual unsigned occurrencesOf(const Object&) const;
	virtual Object* remove(const Object&) = 0;
	virtual void removeAll() = 0;
	virtual void replaceFrom(int start, int stop, const SeqCltn& replacement, int startAt =0) = 0;
        virtual void reSize(unsigned) = 0;
	virtual unsigned size() const = 0;
	virtual const Class* species() const;
};

#endif
