#ifndef	NIHCLCONFIG_H
#define	NIHCLCONFIG_H

/*$Header: /afs/.alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/nihclconfig.h,v 3.13 92/12/19 15:42:34 sandy Exp $*/

/* nihclconfig.h -- NIHCL configuration file

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	nihclconfig.h,v $
 * Revision 3.13  92/12/19  15:42:34  sandy
 * corrected handling of JMP_BUF
 * sgi compatible
 * 
 * Revision 3.12  92/06/17  11:40:48  sandy
 * __mips and ultrix compatible
 * 
 * Revision 3.11  92/05/25  18:13:11  sandy
 * ultrix is type BSD
 * 
 * Revision 3.10  91/02/18  21:09:02  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.3  91/02/18  13:38:07  kgorlen
 * Add workaround for BUG_48.
 * 
 * Revision 3.2  91/02/16  11:34:09  kgorlen
 * Add const JMP_BUF overloadings for ENV_PC(), ENV_SP(),
 * and ENV_FP().
 * 
 * Revision 3.1  90/09/18  13:47:33  sandy
 * added cases 1) defined(mips) 2) defined (SVR3) && defined(mips)
 * 
 * Revision 3.0  90/05/22  08:58:56  kgorlen
 * Release for 1st edition.
 * 
*/

// nihclconfig.h -- NIHCL configuration file

#include <signal.h>
#include <setjmp.h>

#ifdef u3b
#define att3b
#endif
#ifdef u3b2
#define att3b
#endif
#ifdef u3b5
#define att3b
#endif
#ifdef u3b15
#define att3b
#endif

/* Machine Model Implementation Status:

	sun/UCB42BSD		implemented and tested
*/

// Operating System (only one can be defined)

//#define SYSVR2
//#define SYSVR3
//#define UCB42BSD
//#define UCB43BSD

#if defined(att3b) || defined(hpux) || defined(sgi)
#define SYSVR3
#endif

#ifdef mc300
// default att universe on MASSCOMP
#define SYSV
// ucb universe on MASSCOMP
//#define UCB42BSD
#endif

#ifdef ibm032
// default AOS 4.3 on RT PC
#define UCB43BSD
// AIX on RT PC
//#define SYSVR2
#endif

#if defined(vax) || defined(__mips)
#define UCB42BSD
#endif

#if defined(sun)

#include <sys/types.h>
#ifndef howmany
#define UCB42BSD
#define SUNOS3
#else
#define UCB43BSD
#define SUNOS4
#endif

#endif

#if defined(SYSVR2) || defined(SYSVR3)
#ifndef SYSV
#define	SYSV
#endif
#endif

#if defined(UCB42BSD) || defined(UCB43BSD)
#ifndef BSD
#define BSD
#endif
#endif

inline unsigned mod_sizeof_short(unsigned i)	{
  return sizeof(short)&sizeof(short)-1 ? i%sizeof(short) : i&sizeof(short)-1; }
inline unsigned mod_sizeof_int(unsigned i)	{
  return sizeof(int)&sizeof(int)-1 ? i%sizeof(int) : i&sizeof(int)-1; }
inline unsigned mod_sizeof_long(unsigned i)	{
  return sizeof(long)&sizeof(long)-1 ? i%sizeof(long) : i&sizeof(long)-1; }
inline unsigned mod_sizeof_float(unsigned i)	{
  return sizeof(float)&sizeof(float)-1 ? i%sizeof(float) : i&sizeof(float)-1; }
inline unsigned mod_sizeof_double(unsigned i)	{
  return sizeof(double)&sizeof(double)-1 ? i%sizeof(double) : i&sizeof(double)-1; }
inline unsigned mod_sizeof_ptr(unsigned i)	{
  return sizeof(void*)&sizeof(void*)-1 ? i%sizeof(void*) : i&sizeof(void*)-1; }

#if defined(att3b) || defined(mc300) || defined(ibm032) || defined(sun) || defined(vax) || defined(i386) || defined(hpux) || defined(mips) || defined(__mips)

inline unsigned div_bitsize_char(unsigned i)	{ return i >> 3; }
inline unsigned mod_bitsize_char(unsigned i)	{ return i & 7; }
inline unsigned div_bitsize_int(unsigned i)	{ return i >> 5; }
inline unsigned mod_bitsize_int(unsigned i)	{ return i & 0x1f; }
inline unsigned div_sizeof_short(unsigned i)	{ return i >> 1; }
inline unsigned div_sizeof_int(unsigned i)	{ return i >> 2; }
inline unsigned div_sizeof_long(unsigned i)	{ return i >> 2; }
inline unsigned div_sizeof_float(unsigned i)	{ return i >> 2; }
inline unsigned div_sizeof_double(unsigned i)	{ return i >> 3; }
inline unsigned div_sizeof_ptr(unsigned i)	{ return i >> 2; }

const int UNINITIALIZED	=0xa5a5a5a5;	// data value to flag uninitialized variables 

#endif

#if defined(att3b) || defined(mc300) || defined(vax) || defined(ibm032) || defined(sun) || defined(i386) || defined(mips) || defined(__mips)

#define STACK_GROWS_DOWN 1

#endif

#if defined(BSD) || defined(mc300) || defined(hpux) || defined(SVR3)
// defined if select(2) implemented
#define HAVE_SELECT
#endif

// defines for interfacing with ASTs or signals

#if defined(mc300)

#ifndef DEBUG_PROCESS
#define	AST_DISABLE	int prior_AST_state = (Scheduler::astActive()? 127 : setpri(127))
#else
#define	AST_DISABLE	int prior_AST_state = (Scheduler::astActive()? 0 : setpri(0))
#endif

#define AST_ENABLE	if (!Scheduler::astActive()) setpri(prior_AST_state)
#define	AST_STATE	setpri(-1)
#define AST_SAVE(m)	m = prior_AST_state
#define AST_RESTORE(m)	setpri(m)
#define AST_PAUSE	astpause(0,1000)

#else
#if defined(BSD) || defined(hpux)

#ifndef DEBUG_PROCESS
#define	AST_DISABLE	int prior_AST_state = (Scheduler::astActive()? 0xFFFFFFFF : sigblock(0xFFFFFFFF))
#else
#define AST_DISABLE	int prior_AST_state = (Scheduler::astActive()? 0x0 : sigblock(0x0))
#endif

#define AST_ENABLE	if (!Scheduler::astActive()) sigsetmask(prior_AST_state)
#define	AST_STATE	sigblock(0)
#define AST_SAVE(m)	m = prior_AST_state
#define	AST_RESTORE(m)	sigsetmask(m)
#define	AST_PAUSE	sigpause(0)

#endif/*BSD*/

#if defined(SYSVR2)

// Signals do not queue under System V R2, so they are unusable

#define	AST_DISABLE
#define AST_ENABLE
#define	AST_STATE	0
#define AST_SAVE(m)
#define	AST_RESTORE(m)
#define	AST_PAUSE

#endif/*SYSVR2*/
#endif/*mc300*/

// setjmp()/longjmp() context switching for Processes -- see HeapProc.c
//  for additional machine-dependent code.

#if defined(ibm032) && defined(UCB43BSD)
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return _setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ _longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF env)		{ return (unsigned&)env[10]; }
inline unsigned& ENV_SP(JMP_BUF env)		{ return (unsigned&)env[0]; }
inline unsigned& ENV_FP(JMP_BUF env)		{ return (unsigned&)env[0]; }	// register used for FP varies
#endif

#if defined(sun)

#ifdef SUNOS3
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF env)		{ return (unsigned&)env[0]; }
inline unsigned& ENV_SP(JMP_BUF env)		{ return (unsigned&)env[14]; }
inline unsigned& ENV_FP(JMP_BUF env)		{ return (unsigned&)env[13]; }
#endif

#ifdef SUNOS4

#ifdef mc68000
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return _setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ _longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF	env)		{ return (unsigned&)env[3]; }
inline unsigned& ENV_SP(JMP_BUF	env)		{ return (unsigned&)env[2]; }
inline unsigned& ENV_FP(JMP_BUF	env)		{ return (unsigned&)env[15]; }
#endif

#ifdef sparc
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return _setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ _longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF	env)		{ return (unsigned&)env[3]; }
inline unsigned& ENV_SP(JMP_BUF	env)		{ return (unsigned&)env[2]; }
inline unsigned& ENV_FP(JMP_BUF	env)		{ return ((unsigned*)ENV_SP(env))[14]; }
#endif

#ifdef i386
NOT YET IMPLEMENTED
#endif

#endif
#endif

#if defined(mc300)
#ifdef SYSV
struct JMP_BUF {
	jmp_buf jbuf;
	long sigmask;
};
inline int SETJMP(JMP_BUF& env)			{ env.sigmask = AST_STATE; return setjmp(env.jbuf); }
inline void LONGJMP(JMP_BUF& env, int val)	{ AST_RESTORE(env.sigmask); longjmp(env.jbuf,val); }
inline int _SETJMP(JMP_BUF& env)		{ return setjmp(env.jbuf); }
inline void _LONGJMP(JMP_BUF& env, int val)	{ longjmp(env.jbuf,val); }
inline unsigned& ENV_PC(JMP_BUF& env)		{ return (unsigned&)env.jbuf[0]; }
inline unsigned& ENV_SP(JMP_BUF& env)		{ return (unsigned&)env.jbuf[12]; }
inline unsigned& ENV_FP(JMP_BUF& env)		{ return (unsigned&)env.jbuf[11]; }
#endif
#ifdef UCB42BSD
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return _setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ _longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF env)		{ return (unsigned&)env[0]; }
inline unsigned& ENV_SP(JMP_BUF env)		{ return (unsigned&)env[12]; }
inline unsigned& ENV_FP(JMP_BUF env)		{ return (unsigned&)env[11]; }
#endif
#endif

#ifdef mips
#if defined(IRIX_PROCESS) || defined(ULTRIX_PROCESS)
typedef jmp_buf JMP_BUF;
inline int SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline int _SETJMP(JMP_BUF env)			{ return setjmp(env); }
inline void _LONGJMP(JMP_BUF env, int val)	{ longjmp(env,val); }
inline unsigned& ENV_PC(JMP_BUF	env)		{ return (unsigned&)env[JB_PC]; }
inline unsigned& ENV_SP(JMP_BUF	env)		{ return (unsigned&)env[JB_SP]; }
inline unsigned& ENV_FP(JMP_BUF	env)		{ return (unsigned&)env[JB_GP]; }
#endif
#endif

#ifdef BUG_48
inline unsigned ENV_PC(const JMP_BUF env)	{ return ENV_PC((JMP_BUF&)env); }
inline unsigned ENV_SP(const JMP_BUF env)	{ return ENV_SP((JMP_BUF&)env); }
inline unsigned ENV_FP(const JMP_BUF env)	{ return ENV_FP((JMP_BUF&)env); }
#endif
#if defined(sgi)
typedef int	jmp_buf[_JBLEN];
extern int	setjmp(jmp_buf);
extern void	longjmp(jmp_buf, int);
#endif /* sgi */
#endif
