/* Test class IdentDict

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	iddictio.c,v $
 * Revision 3.13  92/07/26  15:16:12  sandy
 * *** empty log message ***
 * 
 * Revision 3.12  92/07/26  15:04:11  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:55:27  sandy
 * DECCXX compatible
 * reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:36  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  91/02/07  14:11:34  kgorlen
 * Use fstreams and close them.
 * 
 * Revision 3.0  90/05/20  00:29:16  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/iddictio.c,v 3.13 92/07/26 15:16:12 sandy Exp $";

#include <nihcl/Assoc.h>
#include <nihcl/Bitset.h>
#include <nihcl/IdentDict.h>
#include <nihcl/OrderedCltn.h>
#include <nihcl/Point.h>
#include <nihcl/Rectangle.h>
#include <nihcl/Set.h>
#include <nihcl/SortedCltn.h>
#include <nihcl/Stack.h>
#include <nihcl/String.h>
#include <nihcl/OIOnih.h>
#include <fstream.h>

Object* testStore()
{
	Bitset& bitset = *new Bitset(Bitset::bit(4)|Bitset::bit(6));
	IdentDict& iddict = *new IdentDict;
	OrderedCltn& orderedcltn = *new OrderedCltn;
	Point& point = *new Point(1,2);
	Rectangle& rect = *new Rectangle(0,1,2,3);
	Set& set = *new Set;
	SortedCltn& sortedcltn = *new SortedCltn;
	Stack& stack = *new Stack;
	String& str = *new String("Hello, world!");
	orderedcltn.add(point); orderedcltn.add(rect); orderedcltn.add(str);
	stack.push(bitset); stack.push(orderedcltn);
	sortedcltn.add(*new String("Huey"));
	sortedcltn.add(*new String("Dewey"));
	sortedcltn.add(*new String("Louie"));
	iddict.add(*new Assoc(orderedcltn,point));
	iddict.add(*new Assoc(bitset,rect));
	iddict.add(*new Assoc(sortedcltn,stack));
	set.add(orderedcltn);
	set.add(stack);
	set.add(sortedcltn);
	set.add(iddict);
	OrderedCltn& monster = *new OrderedCltn;
	monster.add(set); monster.add(*set.deepCopy());
	return &monster;
}

#include <fcntl.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif

main()
{
	cout << "Test storeOn" << endl;
	char* fileName = "iddicta";
	Object* a = testStore();
	ofstream out(fileName);
	{ // storeOn a to stream attached to fileName
           OIOnihout nihout(out); 
           a->storeOn(nihout); 
        }
	cout << "Test readFrom" << endl;
	Object* b;
        { // readFrom b from stream attached to fileName
	   ifstream in(fileName);
           OIOnihin nihin(in);
	   b = Object::readFrom(nihin);
	}
	cout << "*** object stored:" << endl << *a << endl;
	cout << "*** object read:" << endl << *b << endl;
	fileName = "iddictb";
        { // storeOn b to stream attached to fileName
	   out.open(fileName);
           OIOnihout nihout(out);
	   b->storeOn(nihout);
	}
	out.close();
}
