/* Test class IdentDict

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	identdict.c,v $
 * Revision 3.12  92/07/26  15:04:12  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:56:46  sandy
 * DECCXX compatible
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:38  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.0  90/05/20  18:12:42  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/identdict.c,v 3.12 92/07/26 15:04:12 sandy Exp $";

#include <nihcl/Point.h>
#include <nihcl/IdentDict.h>
#include <nihcl/Assoc.h>
#include <nihcl/AssocInt.h>
#include <nihcl/SortedCltn.h>
#include <nihcl/OIOnih.h>
#include <fstream.h>
#include <fcntl.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif

const char* fileName = "identdict.obj";

Point pkey;
#define POINT(X,Y)  *(pkey.x(X),pkey.y(Y),&pkey)

Integer ikey;
#define INTEGER(X)  *(ikey.value(X), &ikey)

main()
{
	cout << "\nTest class IdentDict" << endl;
	IdentDict d(16);
	Point a(1,1), b(1,2), c(1,3);
	AssocInt asc(c,3);
	d.add(*new AssocInt(a,1));
	d.add(*new AssocInt(b,2));
	d.add(asc);
	cout << "d = ";  d.asSortedCltn().dumpOn(cout);
	cout << "d.atKey(a): " << *(d.atKey(a)) << endl;
	cout << "d.includesKey(Point(1,1)): " << d.includesKey(POINT(1,1)) << endl;
	d.atKey(a,*new Integer(0));
	cout << "d.atKey(a): " << *(d.atKey(a)) << endl;
	cout << "d.includesAssoc(asc): " << d.includesAssoc(asc) << endl;
	cout << "d.includesKey(" << (*asc.key()) << "): " << d.includesKey(*asc.key()) << endl;
	cout << "d.keyAtValue(Integer(0)) = " << *d.keyAtValue(INTEGER(0)) << endl;
	d.removeKey(c);
	cout << "d.includesAssoc(asc): " << d.includesAssoc(asc) << endl;
	cout << "d.includesKey(" << (*asc.key()) << "): " << d.includesKey(*asc.key()) << endl;
	Point p = c;
	d.add(asc);
	d.add(*new AssocInt(p,4));
	cout << "d = ";  d.asSortedCltn().dumpOn(cout);
	{
 	    ofstream out(fileName);
	    OIOnihout oout(out);
	    d.storeOn(oout);
	}
	IdentDict* dp =NULL;
        {
	    ifstream in(fileName);
	    OIOnihin oin(in);
	    dp = IdentDict::readFrom(oin);
	}
	dp->asSortedCltn().dumpOn(cout);
	SortedCltn keys,vals;
	cout << "d.addKeysTo(keys): " << dp->addKeysTo(keys) << endl;
	cout << "d.addValuesTo(vals): " << dp->addValuesTo(vals) << endl;
}
