/* Test class IdentSet

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	identset.c,v $
 * Revision 3.12  92/07/26  15:04:13  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:57:31  sandy
 * DECCXX compatible
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:40  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.0  90/05/20  00:29:19  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/identset.c,v 3.12 92/07/26 15:04:13 sandy Exp $";

#include <nihcl/Point.h>
#include <nihcl/IdentSet.h>
#include <nihcl/OIOnih.h>
#include <fstream.h>
#include <fcntl.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif

const char* fileName = "identset.obj";

main()
{
	cout << "\nTest class IdentSet" << endl;
	Point A(1,1);
	Point B(1,1);
	IdentSet s(16);
	s.add(A);
	cout << "s = " << s << endl;
	cout << "s.includes(A): " << s.includes(A) << endl;
	cout << "s.includes(B): " << s.includes(B) << endl;
	s.add(B);
	s.dumpOn(cout);
        { // storeOn s to stream attached to fileName
	    ofstream out(fileName);
	    OIOnihout oout(out);
	    s.storeOn(oout);
	}
	IdentSet* tp;
	{ // readFrom tp from stream attached to fileName
	    ifstream in(fileName);
	    OIOnihin oin(in);
	    tp = IdentSet::readFrom(oin);
	}
	tp->dumpOn(cout);
}
