/* Test class Iterator

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	iterator.c,v $
 * Revision 3.12  92/07/26  15:04:14  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:57:55  sandy
 * DECCXX compatible
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:42  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  91/02/07  13:45:26  kgorlen
 * Use fstreams and close them.
 * 
 * Revision 3.0  90/05/20  00:29:20  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/iterator.c,v 3.12 92/07/26 15:04:14 sandy Exp $";

#include <nihcl/Iterator.h>
#include <nihcl/LinkedList.h>
#include <nihcl/OrderedCltn.h>
#include <nihcl/Set.h>
#include <nihcl/Heap.h>
#include <nihcl/Point.h>
#include <nihcl/LinkOb.h>
#include <nihcl/OIOnih.h>
#include <fstream.h>
#include <fcntl.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif

const char* fileName = "iterator.obj";

main()
{
	cout << "\nTest class Iterator" << endl;
	OrderedCltn c,x;
	{ for (int j=0; j<6; j++) c.add(*new Point(j,j)); }
	c.dumpOn(cout);  cout.flush();
	Set s;
	s = c.asSet();
	s.dumpOn(cout);  cout.flush();
	LinkedList l;
	Iterator i(s);
	Object* p;
	while (p = i++) l.add(*new LinkOb(*p));
	l.dumpOn(cout);  cout.flush();
	Heap h;
	h = c.asHeap();
	h.dumpOn(cout); cout.flush();
	x.add(c); x.add(l); x.add(h);

    DO(x,Collection,cp) {
	cout << "\nTest Iterator(" << cp->className() << ").storeOn()" << endl;
	Iterator ii(*cp);
	ii.dumpOn(cout);  cout.flush();
	{ for (int j=0; j<3; j++) cout << *ii++; }
	cout << endl;
	ii.dumpOn(cout);  cout.flush();
	{ // storeOn ii to stream attached to fileName
	    ofstream out(fileName);
	    OIOnihout nihout(out);
	    ii.storeOn(nihout);
	}
	cout << "\nTest Iterator(" << cp->className() << ") readFrom()" << endl;
	Iterator* ip;
	{ // readFrom ip from stream attached to fileName
	    ifstream in(fileName);
	    OIOnihin nihin(in);
	    ip = Iterator::readFrom(nihin);
	}
	ip->dumpOn(cout);  cout.flush();
	while (p = (*ip)++) cout << *p;
	Collection* tcp=(Collection*)ip->collection();
	delete ip;
	delete tcp;

	cout << "\nTest Iterator(" << cp->className() << ").deepCopy()" << endl;
	ip = Iterator::castdown(ii.deepCopy());
	ip->dumpOn(cout);  cout.flush();
	while (p = (*ip)++) cout << *p;
	cout << "\nTest Iterator(" << cp->className() << ").reset()" << endl;
	ip->reset();
	ip->dumpOn(cout);  cout.flush();
	while (p = (*ip)++) cout << *p;
	cout << endl;
	tcp=(Collection*)ip->collection();
	delete ip;
	delete tcp;
    } OD;
}
