/* Test class KeySortCltn

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	keysortcltn.c,v $
 * Revision 3.12  92/07/26  15:04:14  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:58:22  sandy
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:45  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.2  90/12/22  17:41:21  kgorlen
 * Break up to avoid yacc stack overflow.
 * 
 * Revision 3.1  90/11/11  09:18:29  kgorlen
 * Replace calls to includesKey() by calls to includes().
 * Replace calls to occurrencesOfKey() by calls to occurrencesOf().
 * Replace calls to removeKey() by calls to remove().
 * 
 * Revision 3.0  90/05/20  00:29:23  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/keysortcltn.c,v 3.12 92/07/26 15:04:14 sandy Exp $";

#include <nihcl/KeySortCltn.h>
#include <nihcl/String.h>
#include <nihcl/Date.h>
#include <nihcl/Float.h>
#include <nihcl/Time.h>
#include <nihcl/Integer.h>

KeySortCltn c;

String skey(1);
#define STRING(X)	*(skey=X,&skey)

static void part1()
{
	c.addAssoc(*new String("A"),*new String("Ant"));
	c.addAssoc(*new String("M"),*new String("Man"));
	c.addAssoc(*new String("C"),*new String("Cat"));
	c.addAssoc(*new String("E"),*new String("Emu"));
	c.addAssoc(*new String("H"),*new Date(25,"Dec",85));
	c.addAssoc(*new String("J"),*new Float(98.6));
	c.addAssoc(*new String("E"),*new String("Eeyore"));
	c.addAssoc(*new String("Z"),*new Time(Date(29,"Jan",63),21,30));

	c.printOn(cout); cout << endl;

	int k;
	k = c.findIndexOf(STRING("A"));
 	cout << "index " << k << " before key A" << endl;
	k = c.findIndexOf(STRING("M"));
 	cout << "index " << k << " before key M" << endl;
	k = c.findIndexOf(STRING("C"));
 	cout << "index " << k << " before key C" << endl;
	k = c.findIndexOf(STRING("E"));
 	cout << "index " << k << " before key E" << endl;
	k = c.findIndexOf(STRING("Z"));
 	cout << "index " << k << " before key Z" << endl;
	k = c.findIndexOf(STRING("F"));
 	cout << "index " << k << " before key F" << endl;
	k = c.findIndexOf(STRING("@"));
 	cout << "index " << k << " before key @" << endl;
	k = c.findIndexOf(STRING("["));
 	cout << "index " << k << " before key [" << endl;
}

static void part2()
{
	KeySortCltn clone = *KeySortCltn::castdown(c.copy());
 	cout << "clone isEqual c: " << c.isEqual(clone) << endl;
 	cout << "clone == c: " << (c == (clone)) << endl;
 	cout << "clone != c: " << (c != (clone)) << endl;
 	cout << "c.compare(clone) = " << c.compare(clone) << endl;
 	cout << "c.includes(String(\"J\")) = " 
             << c.includes(STRING("J")) << endl;
 	cout << "c.includes(String(\"K\")) = " 
             << c.includes(STRING("K")) << endl;
 	cout << "c.occurrencesOf(String(\"Q\")) = " 
             << c.occurrencesOf(STRING("Q")) << endl;
 	cout << "c.occurrencesOf(String(\"M\")) = " 
             << c.occurrencesOf(STRING("M")) << endl;
 	cout << "c.occurrencesOf(String(\"E\")) = " 
             << c.occurrencesOf(STRING("E")) << endl;

	cout << "atKey(String(\"J\")) = " << *c.atKey(STRING("J"))
	     << endl;
	cout << "atKey(String(\"N\")) = " << *c.atKey(STRING("N"))
	     << endl;
}

static void part3()
{
	OrderedCltn o;
	c.addValuesTo(o);
	c.addKeysTo(o);
	cout << "\nOrderedCltn o =" << endl;
	cout << o << endl;

	SortedCltn b;
	c.addContentsBeforeTo(STRING("E"), b);
	cout << "\nSortedCltn b =" << endl;
	cout << b << endl;

	cout << "*c.remove(String(\"Z\")) = " << *c.remove(STRING("Z")) << endl;
	cout << "*c.remove(String(\"Q\")) = " << *c.remove(STRING("Q")) << endl;
	cout << "*c.remove(String(\"E\")) = " << *c.remove(STRING("E")) << endl;
	c.printOn(cout); cout << endl;

	const int ARRAY_SIZE = 4;
	ArrayOb x(ARRAY_SIZE), y(ARRAY_SIZE), z(ARRAY_SIZE);
	String s0("apple"), s1("bat"), s2("cat");
	String s3("gopher"), s4("dog"), s5("eagle");

	int i;
	for (i = 0; i < ARRAY_SIZE - 1; i++)
		switch (i) {
			case (0):
				x[i] = y[i] = z[i] = &s0;
				break;
			case (1):
				x[i] = y[i] = z[i] = &s1;
				break;
			case (2):
				x[i] = y[i] = z[i] = &s2;
				break;
		} /* switch */

	x[ARRAY_SIZE - 1] = &s3;
	y[ARRAY_SIZE - 1] = &s4;
	z[ARRAY_SIZE - 1] = &s5;

	KeySortCltn d;

	d.addAssoc(x, *new Integer(0));
	d.addAssoc(y, *new Integer(1));
	d.addAssoc(z, *new Integer(2));
	cout << endl; d.printOn(cout); cout << endl;
	int k;
	k = d.findIndexOf(y);
 	cout << "index "; y.printOn(cout); cout << "\nbefore key " << k << endl;
}

main()
{
	cout << "\nTest class KeySortCltn" << endl;
	part1();
	part2();
	part3();
}
