/* Test Object I/O

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	oio.c,v $
 * Revision 3.13  92/08/12  17:55:02  sandy
 * local getopt() no longer needed
 * 
 * Revision 3.12  92/07/26  15:04:34  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  14:58:56  sandy
 * DECCXX compatible
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:42:59  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.3  91/02/07  14:11:45  kgorlen
 * Use fstreams and close them.
 * 
 * Revision 3.2  90/11/13  22:30:30  kgorlen
 * Update to use new ReadFromTbl/StoreOnTbl functions.
 * 
 * Revision 3.1  90/09/18  14:00:32  sandy
 * changed optarg to opt_arg to avoid name conflict under IRIX
 * 
 * Revision 3.0  90/05/20  00:29:29  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/oio.c,v 3.13 92/08/12 17:55:02 sandy Exp $";

#include <fstream.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif
#include <nihcl/nihclconfig.h>
#include <nihcl/ArrayOb.h>
#include <nihcl/Arraychar.h>
#include <nihcl/Assoc.h>
#include <nihcl/Bag.h>
#include <nihcl/Bitset.h>
#include <nihcl/Date.h>
#include <nihcl/Dictionary.h>
#include <nihcl/FDSet.h>
#include <nihcl/Float.h>
#include <nihcl/Fraction.h>
#include <nihcl/Heap.h>
#include <nihcl/LinkedList.h>
#include <nihcl/LinkOb.h>
#include <nihcl/OrderedCltn.h>
#include <nihcl/Point.h>
#include <nihcl/Range.h>
#include <nihcl/Rectangle.h>
#include <nihcl/Set.h>
#include <nihcl/SortedCltn.h>
#include <nihcl/Stack.h>
#include <nihcl/String.h>
#include <nihcl/Time.h>
#include <nihcl/OIOnih.h>
#include <nihcl/OIOfd.h>

Object* testStore()
{
	ArrayOb& arrayob = *new ArrayOb(4);
	Arraychar& arraychar = *new Arraychar(26);
	Bag& bag = *new Bag(100);
	Bitset& bitset = *new Bitset(4,6);
	Date& date = *new Date(11,"Nov",48);
	Dictionary& dict = *new Dictionary(100);
	FDSet& fdset = *new FDSet(); fdset[0] = fdset[1] = fdset[19] = 1;
	Float& flt = *new Float(3.1415);
	Fraction& fract = *new Fraction(22,7);
	Heap& heap = *new Heap;
	LinkedList& linkedlist = *new LinkedList;
	OrderedCltn& orderedcltn = *new OrderedCltn;
	Point& point = *new Point(1,2);
	Range& range = *new Range(-1,1);
	Rectangle& rect = *new Rectangle(0,1,2,3);
	Set& set = *new Set(100);
	SortedCltn& sortedcltn = *new SortedCltn;
	Stack& stack = *new Stack;
	String& str = *new String("123456789a123456789b123456789c123456789d123456789e123456789f123456789g12345678\012h Hello, world!\t{\033\"\\}");
	Time& time = *new Time(date,1,2,3);
	
	arrayob[0] = &bitset; arrayob[1] = &point; arrayob[2] = &str;
	for (int i = 0; i < 26; i++) arraychar[i] = "abcdefghijklmnopqrstuvwxyz"[i];
	orderedcltn.add(point); orderedcltn.add(rect); orderedcltn.add(str);
	orderedcltn.add(flt); orderedcltn.add(fract); orderedcltn.add(range);
	orderedcltn.add(date); orderedcltn.add(time); orderedcltn.add(fdset);
	stack.push(bitset); stack.push(orderedcltn);
	bag.addWithOccurrences(point,1);
	bag.addWithOccurrences(rect,2);
	bag.addWithOccurrences(str,3);
	bag.add(orderedcltn);
	sortedcltn.add(*new String("Huey"));
	sortedcltn.add(*new String("Dewey"));
	sortedcltn.add(*new String("Louie"));
	heap.add(*new String("Dasher"));
	heap.add(*new String("Dancer"));
	heap.add(*new String("Prancer"));
	heap.add(*new String("Vixen"));
	heap.add(*new String("Comet"));
	heap.add(*new String("Cupid"));
	heap.add(*new String("Donder"));
	heap.add(*new String("Blitzen"));
	dict.add(*new Assoc(orderedcltn,point));
	dict.add(*new Assoc(bag,rect));
	dict.add(*new Assoc(sortedcltn,stack));
	linkedlist.add(*new LinkOb(point));
	linkedlist.add(*new LinkOb(rect));
	linkedlist.add(*new LinkOb(bitset));
	linkedlist.add(*new LinkOb(str));
	
	set.add(arrayob);
	set.add(arraychar);
	set.add(bag);
	set.add(dict);
	set.add(heap);
	set.add(linkedlist);
	set.add(orderedcltn);
	set.add(sortedcltn);
	set.add(stack);
	
	OrderedCltn& monster = *new OrderedCltn;
	monster.add(set); monster.add(*set.deepCopy());
	return &monster;
}

#include <fcntl.h>
#ifdef __DECCXX
extern "C" {
     int getopt(int argc, char** argv, char* optstring);
}
#endif

main(int argc, char** argv)
{
	extern int optind;		// used by getopt()
	extern char* optarg;		// used by getopt()
	char* filea = "oio.obj";
	char* fileb;
	bool binaryIO = NO;	// test binary storeOn/readFrom flag
	bool dumpOpt = NO;	// dump read object on cout
	bool filebOpt = NO;	// file to store object read specified

// parse command options	

	int c;
	while ((c = getopt (argc, argv, "bd")) != EOF)
		switch	(c) {
			case 'b': binaryIO = YES; break;
			case 'd': dumpOpt = YES; break;
			case '?':
				cerr << "usage: [ -bd ] [ filea [ fileb ] ]\n ";
				exit(2);
		}
	if (optind < argc) filea = argv[optind++];
	if (optind < argc) {
		fileb = argv[optind++];
		filebOpt = YES;
	}
				
	Object* a = testStore();
	Object* b;
	OrderedCltn classesOut, objectsOut;
	OrderedCltn classesIn, objectsIn;
	
	if (binaryIO) {
		cout << "Test storeOn(OIOofd&)" << endl;
		{ // storeOn a to stream attatched to filea
		    int fd = creat(filea,0664);
		    OIOofd ofd(fd);
		    a->storeOn(ofd);
		    close(fd);
		    classesOut = ofd.classesStored();
		    objectsOut = ofd.objectsStored();
		}
		cout << "Test readFrom(OIOifd&)" << endl;
		{ // readFrom b from stream attached to filea
		    int fd = open(filea,O_RDONLY);
		    OIOifd ifd(fd);
		    b = Object::readFrom(ifd);
		    close(fd);
		    classesIn = ifd.classesRead();
		    objectsIn = ifd.objectsRead();
		}
	}
	else {
		cout << "Test storeOn(OIOout&)" << endl;
		{ // storeOn a to stream attached to filea
		    ofstream out(filea);
		    OIOnihout ostrm(out);
		    a->storeOn(ostrm);
		    classesOut = ostrm.classesStored();
		    objectsOut = ostrm.objectsStored();
		}
		cout << "Test readFrom(OIOin&)" << endl;
		{ // readFrom b from stream attached to filea
		    ifstream in(filea);
		    OIOnihin istrm(in);
		    b = Object::readFrom(istrm);
		    classesIn = istrm.classesRead();
		    objectsIn = istrm.objectsRead();
		}
	}

	
// check classes stored against classes written

	if (classesIn == classesOut) {
		cout << "Classes OK, " << classesIn.size() << " classes stored and read" << endl;
	}
	else {
		cout << "Classes read not equal classes stored" << endl;
		cout << "Classes stored:" << endl;
		cout << classesOut << endl;
		cout << "Classes read:" << endl;
		cout << classesIn << endl;
	}

// check objects stored against objects written

	if (objectsIn.size() == objectsOut.size()) {
		for (int i=0; i < objectsIn.size(); i++) {
			if (objectsIn[i]->isA() != objectsOut[i]->isA()) {
				cout << "Object #" << i << " class mismatch, stored "
					<< *objectsOut[i]->isA() << ", got "
					<< *objectsIn[i]->isA() << endl;
				exit(1);
			}
		}
		cout << "Objects OK, " << objectsIn.size() << " objects stored and read" << endl;
	}
	else {
		cout << "Object I/O error -- " << objectsOut.size() << " objects stored, "
			<< objectsIn.size() << " objects read" << endl;
	}

// compare object stored with object read	
	
	if (a->isEqual(*b)) {
		cout << "SUCCESS! -- stored object equals object read" << endl;
		if (dumpOpt) {
			b->dumpOn(cout);
			cout << endl;
		}
	}
	else {
		cout << "FAILURE! -- stored object does not equal object read" << endl;
		cout << "*** object stored:" << endl;  a->dumpOn(cout);  cout << endl;
		cout << "*** object read:" << endl;  b->dumpOn(cout);  cout << endl;
		exit(1);
	}
	
// store object read	

	if (filebOpt) {
		if (binaryIO) {
			int fd =creat(fileb,0664);
			OIOofd ofd(fd);
			b->storeOn(ofd);
			close(fd);
		}
		else {
			ofstream out(fileb);
			OIOnihout nihout(out);
			b->storeOn(nihout);
		}
	}
}

