/* Test class Regex

	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet:kgorlen@alw.nih.gov

Function:
	
Modification History:
	
$Log:	regex.c,v $
 * Revision 3.12  92/07/26  15:04:38  sandy
 * include directive in for '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/07/26  15:00:42  sandy
 * DECCXX compatible
 *  reworked use of temporary contructions
 * 
 * Revision 3.10  91/02/18  21:43:17  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  91/02/07  14:11:50  kgorlen
 * Use fstreams and close them.
 * 
 * Revision 3.0  90/05/29  13:46:19  kgorlen
 * Release for 1st edition.
 * 
*/
static char rcsid[] = "$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/test/RCS/regex.c,v 3.12 92/07/26 15:04:38 sandy Exp $";

#include <nihcl/Regex.h>
#include <nihcl/OIOnih.h>
#include <fstream.h>
#ifdef __DECCXX
#include <stdlib.h>
#else
#include <osfcn.h>
#endif

void printGroups(const Regex& r, const String& s, ostream& strm =cout)
{
	for (int i=0; i<r.groups(); i++) {
		strm << '\\' << i << ":	" << ((String&)s)(r[i])
			<< "	[" << s << '(' << r[i] << ")]" << endl;
	}
}

void testPattern(Regex& r, const String& s, ostream& strm =cout)
{
	strm << r << " match(" << s << ")? "
		<< (r.match(s) ? "YES" : "NO") << endl;
	printGroups(r,s);
	strm << r << " search(" << s << ")? "
		<< (r.search(s) != -1 ? "YES" : "NO") << endl;
	printGroups(r,s);
	strm << r << " search(" << s << ',' << s.length()-1 << ',' << -(int)s.length()+1 << ")? "
		<< (r.search(s,s.length()-1,-s.length()+1) != -1 ? "YES" : "NO") << endl;
	printGroups(r,s);
	cout << "---" << endl;
}

const char* fileName = "regex.obj";

main()
{
	cout << "\nTest Class Regex" << endl;
	Regex r = "\\([^a-zA-Z]*\\)\\([a-zA-Z]+\\)\\([^a-zA-Z]*\\)";
	testPattern(r,"123First123456789");
	Regex r2 = r;
	testPattern(r2,"123First123456789");
	Regex r3;
	r3 = r;
	testPattern(r3,"123First123456789");
	{ // storeOn r3 to stream attached to fileName
	    ofstream out(fileName);
	    OIOnihout nihout(out);
	    r3.storeOn(nihout);
	}
	Regex* rp;
	{ // readFrom rp from stream attached to fileName
	    ifstream in(fileName);
	    OIOnihin nihin(in);
	    rp = Regex::readFrom(nihin);
	}
	testPattern(*rp,"123First123456789");

	String s;
	while (YES) {
		cout << "Enter PATTERN: "; cin >> r;
		if (cin.eof()) {
			cout << endl;
			exit(0);
		}
		while (YES) {
			cout << "Enter STRING: "; cin >> s;
			if (cin.eof()) {
				cout << endl;
				exit(0);
			}
			if (s.length()==0) break;
			testPattern(r,s);
		}
	}
}
